core/client/urls.py
from django.conf.urls import url
from .views import ClientListView, ClientDeleteView, AddClientView, UpdateClientView,DetailClientView
from django.views.generic.base import RedirectView
urlpatterns = [
    url(r'^$', ClientListView.as_view(), name="index"),
    url(r'^add/$', AddClientView.as_view(), name="add"),
    url(r'^(?P<pk>\d+)/delete/$', ClientDeleteView.as_view(), name="delete"),
    url(r'^(?P<pk>\d+)/update/$', UpdateClientView.as_view(), name="update"),
    url(r'^(?P<pk>\d+)/show/$', DetailClientView.as_view(), name="show"),
    # url(r'^search/$', TweetListView.as_view(), name="list"),


]

core/core/urls.py
from django.conf import settings
from django.conf.urls import url, include
from django.contrib import admin
from django.conf.urls.static import static
from client.views import login_view, logout_view

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^', include('client.urls')),
    url(r'^clients/', include('client.urls', namespace='client')),
    url(r'^visit/', include('vist.urls', namespace='visit')),
    url(r'^safe/', include('safe.urls', namespace='safe')),
    url(r'^appointment/', include('appointments.urls', namespace='appointment')),
    url(r'^lab/', include('labs.urls', namespace='labs')),
    url(r'^login/$', login_view.as_view(), name='login'),
    url(r'^logout/$', logout_view.as_view(), name='logout'),

]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

core/safe/urls.py
from django.conf.urls import url
from .views import AddBillToClient, GetClientBills,UpdateSafeView,SafeDetailView,AddPaymentToClient,GetPaymentsByDay
from django.views.generic.base import RedirectView

urlpatterns = [
    # url(r'^$', VisitListView.as_view(), name="index"),
    url(r'^(?P<pk>\d+)/add/$', AddBillToClient.as_view(), name="add"),
    url(r'^(?P<pk>\d+)/list/$', GetClientBills.as_view(), name="list"),
    url(r'^(?P<pk>\d+)/detail/$', SafeDetailView.as_view(), name="detail"),
    url(r'^(?P<pk>\d+)/add/payment/$', AddPaymentToClient.as_view(), name="add_payment"),
    url(r'^(?P<pk>\d+)/update/$', UpdateSafeView.as_view(), name="update"),
    url(r'^payments/$', GetPaymentsByDay.as_view(), name="filter"),
    # url(r'^search/$', TweetListView.as_view(), name="list"),

]

core/client/models.py
from django.db import models


# Create your models here.
class Client(models.Model):
    name = models.CharField(max_length=60)
    mobile = models.CharField(max_length=20, unique=True)
    diagnose = models.TextField()
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.name

    # def get_due(self):
    #     total_paid = 0
    #     total_cost = 0
    #
    #     for amount in self.visit_set.all():
    #         total_paid += amount.paid
    #         total_cost += amount.cost
    #     return {"total_paid":total_paid,"total_cost":total_cost,"residual_debt":total_cost -total_paid}

core/vist/models.py
from django.db import models
from client.models import Client
# Create your models here.

class Visit(models.Model):
    note = models.TextField(max_length=500)
    client = models.ForeignKey(Client, on_delete=models.CASCADE)
    cost = models.FloatField(default=0)
    paid = models.FloatField(default=0)
    attachment = models.FileField(blank=True)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.client.name

core/client/forms.py
from django import forms
from .models import Client
from django.contrib.auth import (
    authenticate,
    get_user_model,
    login,
    logout,
)


class AddClientForm(forms.Form):
    name = forms.TextInput(attrs={'class': 'form-control'})
    mobile = forms.TextInput(attrs={'class': 'form-control'})


class UserLoginForm(forms.Form):
    username = forms.CharField(
        required=True,
        label="اسم المستخدم",
        widget=forms.TextInput(attrs={'class': 'form-control'})
    )
    password = forms.CharField(
        required=True,
        label="كلمة المرور",
        widget=forms.PasswordInput(attrs={'class': 'form-control'}))

    # def clean(self, *args, **kwargs):
    #     username = self.cleaned_data.get("username")
    #     password = self.cleaned_data.get("password")
    #
    #     user = authenticate(username=username, password=password)
    #     print(user)
    #
    #     if user is None:
    #
    #         raise forms.ValidationError("This user does not exist")
    #
    #     return super(UserLoginForm, self).clean(*args, **kwargs)

core/client/views.py
from uuid import getnode
from .models import Client
from .forms import AddClientForm, UserLoginForm
from django.shortcuts import render, redirect
from django.http import HttpResponse, HttpRequest
from django.contrib import messages

from django.http import HttpResponseRedirect

from django.urls import reverse_lazy, reverse
from django.views.generic import ListView, DeleteView, CreateView, UpdateView, DetailView, View
from django.contrib.auth import (
    authenticate,
    get_user_model,
    login,
    logout,
)


class login_view(View):
    form = UserLoginForm
    template_name = "auth/login.html"
    context = {'form': form}

    def get(self, request, *args, **kwargs):
        if request.user.is_authenticated:
            return HttpResponseRedirect(reverse('client:index'))

        context = self.context
        return render(request, self.template_name, context)

    def post(self, request, *args, **kwargs):
        form = self.form(request.POST)
        context = self.context
        next = request.GET.get('next')
        if form.is_valid():
            username = form.cleaned_data.get("username")
            password = form.cleaned_data.get("password")
            user = authenticate(username=username, password=password)
            if user is None:
                messages.error(
                    request, 'عفوا، هذا المستخدم غير موجود.')
                return render(request, self.template_name, context)

            else:
                login(request, user)
        if next:
            return redirect(next)
        return redirect('/appointment/list')


class logout_view(View):
    def get(self, request, *args, **kwargs):
        return redirect('/')

    def post(self, request, *args, **kwargs):
        logout(request)
        return HttpResponseRedirect(reverse('login'))


# Create your views here.

class ClientListView(ListView):
    model = Client
    template_name = "partials/clients/list_view.html"


class ClientDeleteView(DeleteView):
    model = Client
    template_name = "partials/clients/delete_confirm.html"
    success_url = reverse_lazy("client:index")


class AddClientView(CreateView):
    model = Client
    # form_class = AddClientForm
    template_name = "partials/clients/add_view.html"
    fields = ['name', 'mobile', 'diagnose']

    def form_valid(self, form):
        form.save()
        return super(AddClientView, self).form_valid(form)

    success_url = reverse_lazy("client:index")


class UpdateClientView(UpdateView):
    model = Client
    template_name = "partials/clients/add_view.html"
    fields = ['name', 'mobile', 'diagnose']
    success_url = reverse_lazy("client:index")


class DetailClientView(DetailView):
    model = Client
    template_name = "partials/clients/detail_view.html"

core/templates/partials/clients/add_view.html
{% extends "base.html" %} {% block content %}
<div id="page-wrapper">
  <div class="row">
    <div class="col-lg-12">
      <h1 class="page-header text-center">اضافة مريض</h1>
      <div class="col-lg-12">
        <div class="panel panel-default center-block">
          <div class="panel-body">
            <div class="tab-content">
              <div id="levelInfo" class="tab-pane fade in active">
                <form action="" method="post">
                  {% csrf_token %}
                   {% if form.errors %}
                   {% for field in form %}
                   {% for error in field.errors %}
                  <div class="alert alert-danger">
                    <strong>{{ error|escape }}</strong>
                  </div>
                  {% endfor %}
                  {% endfor %}
                  {% for error in form.non_field_errors %}
                  <div class="alert alert-danger">
                    <strong>{{ error|escape }}</strong>
                  </div>
                  {% endfor %}
                  {% endif %}
                  </ol>
                  {% include "partials/clients/form.html" %}
                  <input type="submit" value="اضف" class="btn btn-success btn-block">
                </form>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!-- /.col-lg-12 -->
</div>
{% endblock content %}

core/templates/partials/clients/delete_confirm.html
{% extends "base.html" %}
{% block content %}
    <div id="page-wrapper">
      <div class="row">
        <div class="col-lg-12">
          <h1 class="page-header text-center"><span style="color:red;">Delete</span> {{object}} ({{object.mobile}})</h1>
          <div class="col-lg-12">
            <div class="panel panel-default center-block">
              <div class="panel-body">
                <div class="tab-content">
                  <div id="levelInfo" class="tab-pane fade in active">
                    <form action="" method="post">{% csrf_token %}
                      <h4><p>Are you sure you want to delete "<span style="color:green;">{{object}}</span>"?</p></h4>
                      <hr>
                      <input class="btn btn-danger" type="submit" value="Delete Client" />
                    </form>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!-- /.col-lg-12 -->
    </div>
{% endblock content %}

core/templates/partials/clients/detail_view.html
{% extends "base.html" %}
{% block content %}
<div id="page-wrapper">
    <div class="row">
        <div class="col-lg-12">
            <h1 class="page-header">{{object.name}}

            </h1>
        </div>
        <div class="col-lg-12">
            <table class="table">

                <tr>
                    <th>Id</th>
                    <td>{{object.id}}</td>
                </tr>
                <tr>
                    <th>Name</th>
                    <td>{{object.name}}</td>
                </tr>
                <tr>
                    <th>Mobile</th>
                    <td>{{object.mobile}}</td>
                </tr>

                <tr>

                <th>To be paid</th>
                <td>{{object.get_due.residual_debt}}</td>
                </tr>
                <th>Diagnose</th>
                <td>{{object.diagnose}}</td>
                </tr>
                <tr>
                    <th>Add a Visit</th>
                    <td><a href="{% url 'visit:add' object.id %}" class="btn btn-warning" title="Edit"
                           data-original-title="Edit">
                        <i class="fa fa-paperclip"></i>
                    </a></td>
                </tr>

            </table>
            <!-- /.table-responsive -->
            <table width="100%" class="table table-striped table-bordered table-hover" id="dataTables-example">
                <thead>
                <tr>
                    <th>ID</th>
                    <th class="text-center">Note</th>
                    <th class="text-center">Image</th>
                    <th>Cost</th>
                    <th>paid</th>
                    <th class="text-center">Created</th>

                </tr>
                </thead>
                <tbody>
                {% for obj in object.visit_set.all %}
                <tr id="ddata-{obj.id}">
                    <td>{{obj.id}}</td>
                    <td>{{obj.note}}</td>
                    <td>
                        {% if obj.attachment %}
                        <img width="100" style="cursor:pointer" onClick="window.location.href='{{obj.attachment.url}}'"
                             src="{{obj.attachment.url}}" alt="{{obj.client.name}}"/>
                        {% else %}
                        No Image
                        {% endif %}
                    </td>
                    <td>{{obj.cost}}</td>
                    <td>{{obj.paid}}</td>
                    <td>{{obj.created_at|timesince}} ago.</td>
                </tr>
                {% endfor %}
                </tbody>
            </table>
        </div>
        <!-- /.col-lg-12 -->
    </div>
    <!-- /.row -->

</div>
{%endblock content%}

core/templates/partials/clients/form.html
<div class="form-group">
    <label for="name" class="pull-right">الاسم</label>
    <input type="text" name="name" value="{%if object.name %}{{object.name}}{%endif%}" class="form-control" required>
</div>
<div class="form-group">
  <label for="mobile" class="pull-right">التليفون</label>
  <input type="text" name="mobile" value="{%if object.mobile %}{{object.mobile}}{%endif%}" class="form-control" required>
</div>
<div class="form-group">
  <label for="mobile" class="pull-right">التشخيص</label>
  <textarea name="diagnose" rows="8" cols="80" class="form-control">{%if object.diagnose %}{{object.diagnose}}{%endif%}</textarea>
</div>

core/templates/partials/clients/list_view.html
{% extends "base.html" %}

{% block content %}
    <div id="page-wrapper">
        <div class="row">
            <div class="col-lg-12">
                <h1 class="page-header">All Clients

                </h1>
            </div>
            <div class="col-lg-12">
                <table width="100%" class="table table-striped table-bordered table-hover" id="dataTables-example">
                    <thead>
                    <tr>
                        <th>التسلسل</th>
                        <th class="text-center">الاسم</th>
                        <th class="text-center">التليفون</th>
                        <th class="text-center">تاريخ الانشاء</th>
                        <th class="text-center">تاريخ التعديل</th>
                        <th class="text-center">الاعدادات</th>
                    </tr>
                    </thead>
                    <tbody>
                    {% for obj in object_list %}
                        <tr id="ddata-{obj.id}">
                            <td>{{ obj.id }}</td>
                            <td><a href="{% url 'client:show' obj.id %}">{{ obj.name }}</a></td>
                            <td>{{ obj.mobile }}</td>
                            <td>{{ obj.created_at|timesince }} ago.</td>
                            <td>{{ obj.updated_at|timesince }} ago.</td>
                            <td class="text-center">
                                <div class="btn-group">

                                    <a href="{% url 'client:delete' obj.id %}" class="btn btn-danger" title="Delete"
                                       data-original-title="Delete">
                                        <i class="fa fa-trash"></i>
                                    </a>
                                    <a href="{% url 'client:update' obj.id %}" class="btn btn-success" title="Edit"
                                       data-original-title="Edit">
                                        <i class="fa fa-pencil"></i>
                                    </a>
                                    <a href="{% url 'visit:add' obj.id %}" class="btn btn-warning" title="Edit"
                                       data-original-title="Edit">
                                        <i class="fa fa-paperclip"></i>
                                    </a>
                                    <a href="{% url 'safe:list' obj.id %}" class="btn btn-info" title="Show"
                                       data-original-title="Show">
                                        <i class="fa fa-eye"></i>
                                    </a>
                                    <a href="{% url 'safe:add' obj.id %}" class="btn btn-warning" title="Add"
                                       data-original-title="Add">
                                        <i class="fa fa-money"></i>

                                    </a>


                                </div>

                            </td>
                        </tr>
                    {% endfor %}
                    </tbody>
                </table>
                <!-- /.table-responsive -->

            </div>
            <!-- /.col-lg-12 -->
        </div>
        <!-- /.row -->

    </div>
{% endblock content %}